#!/usr/bin/env python
# -*- coding: UTF-8 -*-

#Licence: GPLv3.0
#Copyright: Krasimir S. Stefanov

import os
import platform
import locale
import sys
import os.path
import gettext
import pygtk
pygtk.require("2.0")
import gtk
import gtk.glade
import gobject
import re
import gtk.gdk
from threading import Thread
'''
locale.setlocale(locale.LC_ALL, '')
#APP = "vidrop"
if platform.system() == "Windows":
	DIR = "locale"
	os.environ['LANG'] = locale.getdefaultlocale()[0]
else:
	if os.path.exists('./locale'):
		DIR = os.path.join(os.path.dirname(sys.argv[0]),"locale")
	else:
		DIR = "/usr/share/locale"
	
#APP_VERSION = "0.6.8"

gtk.glade.bindtextdomain(APP, DIR)
gtk.glade.textdomain(APP)
gettext.bindtextdomain(APP, DIR)
gettext.textdomain(APP)
_ = gettext.gettext
gettext.install(APP, localedir=DIR)
'''

# localization
APP = "vidrop"
APP_VERSION = "0.6.8"
if platform.system() == "Windows":
	DIR = "locale"
	os.environ['LANG'] = locale.getdefaultlocale()[0]
	os.environ['LANGUAGE'] = locale.getdefaultlocale()[0]
else:
	if os.path.exists('./locale'):
		DIR = os.path.join(os.path.dirname(sys.argv[0]),"locale")
	else:
		DIR = "/usr/share/locale"
locale.setlocale(locale.LC_ALL, '')
gtk.glade.bindtextdomain(APP, DIR)
gtk.glade.textdomain(APP)
gettext.bindtextdomain(APP, DIR)
gettext.textdomain(APP)
gettext.install(APP, localedir=DIR)
global _
_ = gettext.gettext
# /localization




gobject.threads_init()

def check_version():
	try:
		html = urllib.urlopen('http://vidrop.learnfree.eu/version.txt').read()
	except:
		return 0
	
	try:
		NEW_APP_VERSION = re.search('APP_VERSION=(.*)', html).group(1)
	except:
		return 0
	if NEW_APP_VERSION > APP_VERSION:
		return NEW_APP_VERSION
	else:
		return 0

class UpdaterThread(Thread):
	def __init__ (self, callback_done):
		super(UpdaterThread, self).__init__()
		self.callback_done = callback_done
		
	def run(self):
		vercheck = check_version()

		gobject.idle_add(self.callback_done, vercheck)

class vidrop_simple:
	def __init__(self):
		self.pathname = os.path.dirname(sys.argv[0])
		self.abspath = os.path.abspath(self.pathname)
		self.gladefile = self.abspath + "/vidrop.glade"
		self.window5 = gtk.glade.XML(self.gladefile,"window5",APP)
		
		dic = {
			"on_button1_clicked" : self.on_button1_clicked,
			"on_button2_clicked" : self.on_button2_clicked,
			"on_button3_clicked" : self.on_button3_clicked,
			"on_button4_clicked" : self.on_button4_clicked,
			"on_button5_clicked" : self.on_button5_clicked,
			"on_filechooserbutton1_file_set" : self.on_filechooserbutton1_file_set,
			"on_window5_delete_event" : (gtk.main_quit)
		}
		
		self.settings = {}
		
		self.window5.signal_autoconnect (dic)
		
		#list presets
		liststore = gtk.ListStore(gtk.gdk.Pixbuf, gobject.TYPE_STRING, gobject.TYPE_STRING)
		self.window5.get_widget("combobox1").set_model(liststore)
		cell_icon = gtk.CellRendererPixbuf()
		cell0 = gtk.CellRendererText()
		cell1 = gtk.CellRendererText()
		self.window5.get_widget("combobox1").pack_start(cell_icon, False)
		self.window5.get_widget("combobox1").pack_start(cell0, True)
		self.window5.get_widget("combobox1").pack_start(cell1, True)
		self.window5.get_widget("combobox1").add_attribute(cell_icon, 'pixbuf', 0)  
		self.window5.get_widget("combobox1").add_attribute(cell0, 'text', 1)  
		self.window5.get_widget("combobox1").add_attribute(cell1, 'text', 2)  
		self.window5.get_widget("combobox1").get_model().set_sort_column_id(0,gtk.SORT_ASCENDING)
		cell1.set_property('visible',False)
		self.list_presets()
		self.window5.get_widget("filechooserbutton3").set_current_folder(os.getenv('HOME') or os.getenv('USERPROFILE'))				
		self.window5.get_widget("window5").show()
		UpdaterThread(self.vercheck_done).start()
		
	def vercheck_done(self, result):
		if str(result) != '0':
			self.msg_info(_('There is new version of viDrop available (%s)! Check %s for more details.') % (result, '<a href="http://vidrop.learnfree.eu">http://vidrop.learnfree.eu</a>'))
	
	def on_filechooserbutton1_file_set(self, widget):
		filename = self.window5.get_widget("filechooserbutton1").get_filename()
		output = os.popen('mplayer "'+filename+'" -sub-fuzziness 1 -quiet -identify -frames 0').read()
		p = re.compile('ID_FILE_SUB_FILENAME=(.*)')
		result = p.findall(output)
		if result:
			self.window5.get_widget("filechooserbutton2").set_filename(result[0])
		self.window5.get_widget("filechooserbutton3").set_current_folder(os.path.dirname(filename))
		return
		
		
	def list_presets(self):
		if platform.system() == "Windows":
			paths = [
				os.path.abspath(os.path.join(self.abspath,'presets'))
			]
		else:
			paths = [
				os.path.abspath(os.path.join(self.abspath,'presets'))
				, os.path.join(os.getenv("HOME"),".local","share","vidrop","presets")
				
			]
		self.window5.get_widget("combobox1").get_model().set_sort_column_id(1,gtk.SORT_ASCENDING)
	
		self.window5.get_widget("combobox1").get_model().clear()
		list_iter = self.window5.get_widget("combobox1").get_model().append()
		icon = None
		self.window5.get_widget("combobox1").get_model().set(list_iter,0, icon, 1,'', 2,'')
					
		for path in paths:
			if os.path.isdir(path):
				presets = os.listdir(path)
				for preset in presets:
					m = re.search('(.*?)\.ini$',preset)
					if m:
						preset_fullname = os.path.abspath(os.path.join(path,preset))
						list_iter = self.window5.get_widget("combobox1").get_model().append()
						
						icon_file = os.path.abspath(os.path.join(path,m.group(1)+'.png'))
						if os.path.isfile(icon_file):
							icon = gtk.image_new_from_file(icon_file).get_pixbuf()
						else:
							icon = self.window5.get_widget("combobox1").render_icon(gtk.STOCK_FILE, gtk.ICON_SIZE_BUTTON)
						self.window5.get_widget("combobox1").get_model().set(list_iter,0, icon, 1,preset, 2,preset_fullname)
		
		self.window5.get_widget("combobox1").set_active(0)
		
	def on_button1_clicked(self, widget):
		input_file = self.window5.get_widget("filechooserbutton1").get_filename()
		input_subtitle = self.window5.get_widget("filechooserbutton2").get_filename()
		output_dir = self.window5.get_widget("filechooserbutton3").get_filename()
		
		input_file = (' -i "%s"' % input_file) if input_file else ''
		input_subtitle = (' -s "%s"' % input_subtitle) if input_subtitle else ''
		output_dir = (' -o "%s"' % output_dir) if output_dir else ''
		
		i = self.window5.get_widget("combobox1").get_active_iter()
		preset = (' -p "%s"' % self.window5.get_widget("combobox1").get_model().get_value(i,2)) if i else ''
			
		if not input_file:
			self.msg_error(_('No input file specified!'))
			return

		self.window5.get_widget("window5").hide()
		while gtk.events_pending():
			gtk.main_iteration_do()

			
		
		if platform.system() == "Windows":
			exefile = os.path.join('.','vidrop.exe')
			
			if os.path.isfile(exefile):
				vidrop = 'vidrop.exe --convert'
			else:
				pyfile = os.path.join('.','vidrop.py')
				if os.path.isfile(pyfile):
					vidrop = 'python "%s" --convert ' % pyfile
				else:
					self.msg_error(_("Main viDrop executable is missing!"))
					self.window5.get_widget("window5").show()
					return
		else:
			pyfile = os.path.join('.','vidrop.py')
			if os.path.isfile(pyfile):
				vidrop = 'python "%s" --convert' % pyfile
			else:
				vidrop = 'vidrop --convert'	
		
		command = vidrop + input_file + input_subtitle + output_dir + preset
		print command
		os.system(command)
		self.msg_info(_('Transcoding done!'))
		self.window5.get_widget("window5").show()
		
	def on_button2_clicked(self, widget):
		input_file = self.window5.get_widget("filechooserbutton1").get_filename()
		input_subtitle = self.window5.get_widget("filechooserbutton2").get_filename()
		output_dir = self.window5.get_widget("filechooserbutton3").get_filename()
		
		input_file = (' -i "%s"' % input_file) if input_file else ''
		input_subtitle = (' -s "%s"' % input_subtitle) if input_subtitle else ''
		output_dir = (' -o "%s"' % output_dir) if output_dir else ''
		
		i = self.window5.get_widget("combobox1").get_active_iter()
		preset = (' -p "%s"' % self.window5.get_widget("combobox1").get_model().get_value(i,2)) if i else ''

		self.window5.get_widget("window5").hide()
		while gtk.events_pending():
			gtk.main_iteration_do()
			
		if platform.system() == "Windows":
			exefile = os.path.join('.','vidrop.exe')
			if os.path.isfile(exefile):
				vidrop = 'vidrop.exe'
			else:
				pyfile = os.path.join('.','vidrop.py')
				if os.path.isfile(pyfile):
					vidrop = 'python "%s"' % pyfile
				else:
					self.msg_error(_("Main viDrop executable is missing!"))
					self.window5.get_widget("window5").show()
					return
		else:
			pyfile = os.path.join('.','vidrop.py')
			if os.path.isfile(pyfile):
				vidrop = 'python "%s"' % pyfile
			else:
				vidrop = 'vidrop'
				
		command = vidrop + input_file + input_subtitle + output_dir + preset
		print command
		os.system(command)
		gtk.main_quit()
		return

	def on_button3_clicked(self, widget):
		about = gtk.AboutDialog()
		about.set_position(gtk.WIN_POS_CENTER_ALWAYS)

		# about.set_name("liveusb-install")
		about.set_program_name("viDrop")
		about.set_version(APP_VERSION)
		about.set_authors([_("Krasimir S. Stefanov <lokiisyourmaster@gmail.com>")])
		about.set_website("http://skss.learnfree.eu/")
		about.set_translator_credits(_("Bulgarian - Krasimir S. Stefanov <lokiisyourmaster@gmail.com>"))
		about.set_logo(gtk.gdk.pixbuf_new_from_file(os.path.join(self.abspath,'vidrop-logo.png')))
		license = _('''viDrop video transcoder
Copyright (C) 2007-2010  Krasimir S. Stefanov

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.''')
		
		about.set_license(license)
		about.run()
		about.hide()
		return

	def on_button4_clicked(self, widget):
		gtk.main_quit()
		return

	def on_button5_clicked(self, widget):
		input_file = self.window5.get_widget("filechooserbutton1").get_filename()
		input_subtitle = self.window5.get_widget("filechooserbutton2").get_filename()
		output_dir = self.window5.get_widget("filechooserbutton3").get_filename()
		
		input_file = (' -i "%s"' % input_file) if input_file else ''
		input_subtitle = (' -s "%s"' % input_subtitle) if input_subtitle else ''
		output_dir = (' -o "%s"' % output_dir) if output_dir else ''
		
		i = self.window5.get_widget("combobox1").get_active_iter()
		preset = (' -p "%s"' % self.window5.get_widget("combobox1").get_model().get_value(i,2)) if i else ''
			
		if not input_file:
			self.msg_error(_('No input file specified!'))
			return

		self.window5.get_widget("window5").hide()
		while gtk.events_pending():
			gtk.main_iteration_do()
		
		if platform.system() == "Windows":
			exefile = os.path.join('.','vidrop.exe')
			
			if os.path.isfile(exefile):
				vidrop = 'vidrop.exe --preview'
			else:
				pyfile = os.path.join('.','vidrop.py')
				if os.path.isfile(pyfile):
					vidrop = 'python "%s" --preview ' % pyfile
				else:
					self.msg_error(_("Main viDrop executable is missing!"))
					self.window5.get_widget("window5").show()
					return
		else:
			pyfile = os.path.join('.','vidrop.py')
			if os.path.isfile(pyfile):
				vidrop = 'python "%s" --preview' % pyfile
			else:
				vidrop = 'vidrop --preview'	
		
		command = vidrop + input_file + input_subtitle + output_dir + preset
		print command
		os.system(command)
		self.window5.get_widget("window5").show()
		
	def combobox_select(self, cb, text, col = 0):
		model = cb.get_model()
		iter = model.get_iter_first()
		while iter:
			if model.get_value(iter,col) == text:
				cb.set_active_iter(iter)
				return		
			iter = model.iter_next(iter)
			
	def combobox_maketext(self,name):
		cb = self.window5.get_widget(name)
		liststore = gtk.ListStore(str)
		cb.set_model(liststore)
		cell = gtk.CellRendererText()
		cb.pack_start(cell, True)
		cb.add_attribute(cell, 'text', 0)
		
	def msg_error(self,msg):
		dialog = gtk.MessageDialog(self.window5.get_widget("window5"),gtk.DIALOG_MODAL,gtk.MESSAGE_ERROR,gtk.BUTTONS_OK)
		dialog.set_markup(msg)
		dialog.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		dialog.run()
		dialog.destroy()
		
	def msg_info(self,msg):
		dialog = gtk.MessageDialog(self.window5.get_widget("window5"),gtk.DIALOG_MODAL,gtk.MESSAGE_INFO,gtk.BUTTONS_OK)
		dialog.set_markup(msg)
		dialog.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		dialog.run()
		dialog.destroy()		
	
			
if __name__ == '__main__':
	vidrop_simple()
	gtk.main()

